import pytest

from ..utils import Cpt


@pytest.mark.parametrize(['use_stderr'], [[False], [True]])
def test_progcpt_1(capsys, use_stderr):
    total = 1
    fd = None
    if use_stderr:
        import sys

        fd = sys.stderr
    cpt = Cpt("compteur", total, fd=fd)
    for idx in range(total):
        cpt()
    out, err = capsys.readouterr()
    fd_out = err if use_stderr else out
    assert fd_out == 'compteur: 1/{0}\n'.format(total)


@pytest.mark.parametrize(['use_last'], [[True], [False]])
def test_progcpt_2(capsys, use_last):
    total = 2
    cpt = Cpt("compteur", total)
    for idx in range(total):
        cpt()
    if use_last:
        cpt.last()
    out, err = capsys.readouterr()
    assert out == 'compteur: 1/{0}\rcompteur: 2/{0}\n'.format(total)


def test_progcpt_incomplete(capsys):
    total = 10
    cpt = Cpt("compteur", total)
    for idx in range(2):
        cpt()
    cpt.last()
    out, err = capsys.readouterr()
    assert out == 'compteur: 1/{0}\rcompteur: 2/{0}\r\n'.format(total)
